precision highp float;
attribute vec2 aVertex;
uniform vec4 uColor;
uniform float uZ;
uniform mat4 uMVPMatrix;
varying vec4 vColor;
const float K_EARTH_CIRCLE_2 =20037508.0;
const float EARTH_RADIUS_IN_METERS =6378137.0;

float degToRad(float paramDouble){
    return paramDouble * 0.017453292519943295;
}

vec2 latLongAddToPixels(float lat, float lon){


    float var6 = 6378137.0 * degToRad(lon);
    float var8 = sin(degToRad(lat));
    float var10 = log((1.0 + var8) / (1.0 - var8));
    float var12 = EARTH_RADIUS_IN_METERS * var10 / 2.0;
    float var14 = (K_EARTH_CIRCLE_2 + var6) / 0.14929106831550598;
    float var16 = (K_EARTH_CIRCLE_2 - var12) / 0.14929106831550598;

    return vec2(var14, var16);
}

void main() {

    vec2 pixels = latLongAddToPixels(aVertex.x, aVertex.y);

    vec4 position = uMVPMatrix * vec4(pixels.x, pixels.y, uZ, 1.0);
    gl_Position = vec4(position.x, position.y, -1.0 * uZ, position.w);
    vColor = uColor;
}
